Skip to main content
`Ctrl`+`K`

# KSPMonitorSingularValue

Prints the two norm of the true residual and estimation of the extreme singular values of the preconditioned problem at each iteration.

## Synopsis

    #include "petscksp.h"
    PetscErrorCode KSPMonitorSingularValue(KSP ksp, PetscInt n, PetscReal rnorm, PetscViewerAndFormat *vf)

Logically Collective

## Input Parameters

- ksp - the iterative context

- n - the iteration

- rnorm - the two norm of the residual

- vf - The viewer context

## Options Database Key

- -ksp_monitor_singular_value - Activates `KSPMonitorSingularValue()`

## Notes

The `KSPCG` solver uses the Lanczos technique for eigenvalue computation, while `KSPGMRES` uses the Arnoldi technique; other iterative methods do not currently compute singular values.

This is not called directly by users, rather one calls `KSPMonitorSet()`, with this function as an argument, to cause the monitor to be used during the `KSP` solve.

Call `KSPMonitorSingularValueCreate()` to create the context needed by this monitor

## See Also

KSP: Linear System Solvers, `KSP`, `KSPMonitorSet()`, `KSPComputeExtremeSingularValues()`, `KSPMonitorSingularValueCreate()`

## Level

intermediate

## Location

src/ksp/ksp/interface/iterativ.c

Index of all KSP routines
Table of Contents for all manual pages
Index of all manual pages